Loading...
Searching...
No Matches
juce::ImageCache Class Reference

## Detailed Description

A global cache of images that have been loaded from files or memory.

If you're loading an image and may need to use the image in more than one place, this is used to allow the same image to be shared rather than loading multiple copies into memory.

Another advantage is that after images are released, they will be kept in memory for a few seconds before it is actually deleted, so if you're repeatedly loading/deleting the same image, it'll reduce the chances of having to reload it each time.

See also
  Image, ImageFileFormat

The documentation for this class was generated from the following file:

- juce_graphics/images/juce_ImageCache.h

## Static Public Member Functions

static Image | getFromFile (const File &file)
| Loads an image from a file, (or just returns the image if it's already cached).
static Image | getFromMemory (const void *imageData, int dataSize)
| Loads an image from an in-memory image file, (or just returns the image if it's already cached).
static Image | getFromHashCode (int64 hashCode)
| Checks the cache for an image with a particular hashcode.
static void | addImageToCache (const Image &image, int64 hashCode)
| Adds an image to the cache with a user-defined hash-code.
static void | setCacheTimeout (int millisecs)
| Changes the amount of time before an unused image will be removed from the cache.
static void | releaseUnusedImages ()
| Releases any images in the cache that aren't being referenced by active Image objects.

## Member Functions

## getFromFile()

Image juce::ImageCache::getFromFile | ( | const File & | file | ) |

static

Loads an image from a file, (or just returns the image if it's already cached).

If the cache already contains an image that was loaded from this file, that image will be returned. Otherwise, this method will try to load the file, add it to the cache, and return it.

Remember that the image returned is shared, so drawing into it might affect other things that are using it! If you want to draw on it, first call Image::duplicateIfShared()

Parameters

  file | the file to try to load

Returns
  the image, or null if it there was an error loading it

See also
  getFromMemory, getFromCache, ImageFileFormat::loadFrom

## getFromMemory()

Image juce::ImageCache::getFromMemory | ( | const void * | imageData,
|  | int | dataSize )

static

Loads an image from an in-memory image file, (or just returns the image if it's already cached).

If the cache already contains an image that was loaded from this block of memory, that image will be returned. Otherwise, this method will try to load the file, add it to the cache, and return it.

Remember that the image returned is shared, so drawing into it might affect other things that are using it! If you want to draw on it, first call Image::duplicateIfShared()

Parameters

  imageData | the block of memory containing the image data
  dataSize | the data size in bytes

Returns
  the image, or an invalid image if it there was an error loading it

See also
  getFromMemory, getFromCache, ImageFileFormat::loadFrom

## getFromHashCode()

Image juce::ImageCache::getFromHashCode | ( | int64 | hashCode | ) |

static

Checks the cache for an image with a particular hashcode.

If there's an image in the cache with this hashcode, it will be returned, otherwise it will return an invalid image.

Parameters

  hashCode | the hash code that was associated with the image by addImageToCache()

See also
  addImageToCache

## addImageToCache()

void juce::ImageCache::addImageToCache | ( | const Image & | image,
|  | int64 | hashCode )

static

Adds an image to the cache with a user-defined hash-code.

The image passed-in will be referenced (not copied) by the cache, so it's probably a good idea not to draw into it after adding it, otherwise this will affect all instances of it that may be in use.

Parameters

  image | the image to add
  hashCode | the hash-code to associate with it

See also
  getFromHashCode

## setCacheTimeout()

void juce::ImageCache::setCacheTimeout | ( | int | millisecs | ) |

static

Changes the amount of time before an unused image will be removed from the cache.

By default this is about 5 seconds.

## releaseUnusedImages()

void juce::ImageCache::releaseUnusedImages | ( |  | ) |

static

Releases any images in the cache that aren't being referenced by active Image objects.

References Pimpl.

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited